
EnableExplicit

;Nautilus Engine
;Version: 1.00
;Author: Mijikai

;Pathfinding Example


XIncludeFile "nautilus.pbi"

Procedure.i Main()
  Protected *engine.NAUTILUS_ENGINE
  Protected *ortho.NAUTILUS_WORLD
  Protected *collision.NAUTILUS_LOGIC
  Protected x.i
  Protected y.i
  Protected mouse.NE_VECTOR
  Protected mouse_pos.NE_VECTOR
  Protected mouse_index.NE_INDEX
  Protected *world.Ascii
  Protected cam.i
  Protected cam_origin.NE_VECTOR
  Protected cam_clamp.NE_CLAMP
  Protected tile_pos.NE_VECTOR
  Protected tile_link.i
  Protected astar_mask.i
  Protected astar_path.i
  Protected astar_start.NE_INDEX
  Protected astar_stop.NE_INDEX
  Protected astar_pos.NE_INDEX
  *engine = nautilusWindow("ASTAR DEMO",800,600,#NE_WINDOW_NORMAL,320,200,60)
  If *engine
    *engine\RenderAspect()
    *engine\RenderColor($FF6B6951)
    ;-----------------------------------------------------------------
    *ortho = *engine\CreateWorld(16,16,8,8)
    *ortho\TileMapCreate()
    For y = 0 To 15
      For x = 0 To 15
        *world = ?world + (y * 16) + x
        *ortho\TileMapSet(x,y,*world\a)
      Next
    Next
    cam = *ortho\CameraCreate(10,10,300,180)
    cam_origin\x = 8 << 3
    cam_origin\y = 8 << 3
    *ortho\CameraOrigin(cam,@cam_origin)
    ;-----------------------------------------------------------------
    *collision = *engine\CreateLogic()
    astar_mask = *collision\AStarMaskCreate(?world,16,16)
    astar_start\x = 14
    astar_start\y = 14
    ;-----------------------------------------------------------------
    Repeat      
      *engine\InputMouse(@mouse) 
      ;-----------------------------------------------------------------
      *engine\RenderBegin()
      *engine\DrawText(2,2,Str(mouse_index\x) + " x " + Str(mouse_index\y))
      *ortho\Mouse(cam,@mouse,@mouse_pos,@mouse_index)
        *ortho\CameraUpdate(cam,@cam_clamp)
        
        ;-----------------------------------------------------------------
        For y = cam_clamp\min\y To cam_clamp\max\y
          For x = cam_clamp\min\x To cam_clamp\max\x
            *ortho\TileMapToScreen(cam,x,y,@tile_pos,@tile_link)
            If tile_link
              *engine\DrawBox(tile_pos\x,tile_pos\y,8,8) 
            Else
              *engine\DrawBox(tile_pos\x,tile_pos\y,8,8,#False,#True) 
              *engine\DrawBox(tile_pos\x,tile_pos\y,8,8,#False,#False,$976B6951)  
            EndIf
            If x = astar_start\x And y = astar_start\y
              *engine\DrawCircle(tile_pos\x + 4,tile_pos\y + 4,6,#True,$FFFF00FF)
            EndIf
          Next
        Next
        ;-----------------------------------------------------------------
        astar_path = *collision\AStarPathCreate(astar_mask,@astar_start,@mouse_index,#True,#True,100,1000);distance limit (heuristic) / nodes limit (checked nodes)    
        If astar_path
          While  *collision\AStarPath(astar_path,@astar_pos)
            *ortho\TileMapToScreen(cam,astar_pos\x,astar_pos\y,@tile_pos)
            *engine\DrawBox(tile_pos\x,tile_pos\y,8,8,#False,#True,$FF00FF00)
          Wend
          *collision\AStarPathFree(astar_path)
        EndIf
        ;----------------------------------------------------------------- 
      *engine\RenderEnd()  
      
    Until *engine\WindowExit()
    *engine\Release()
  EndIf 
EndProcedure

Main()

End

DataSection
  world:
  !db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
  !db 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
  !db 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
  !db 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
  !db 1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1
  !db 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
  !db 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
  !db 1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1
  !db 1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1
  !db 1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1
  !db 1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1
  !db 1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1
  !db 1,0,0,0,0,0,0,1,1,0,1,1,0,0,0,1
  !db 1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1
  !db 1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1
  !db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
EndDataSection
; IDE Options = PureBasic 5.62 (Windows - x64)
; CursorPosition = 52
; FirstLine = 55
; Folding = -
; EnableXP